package johan;

import java.io.UnsupportedEncodingException;
import java.util.Set;
import com.ingenico.pclservice.IPclServiceCallback;
import com.ingenico.pclservice.PclService;
import com.ingenico.pclservice.TransactionIn;
import com.ingenico.pclservice.TransactionOut;
import com.ingenico.pclservice.PclService.LocalBinder;
import com.ingenico.pclutilities.PclUtilities;
import com.ingenico.pclutilities.PclUtilities.BluetoothCompanion;

import anywheresoftware.b4a.BA.DependsOn;
//import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
//import android.R.string;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.os.AsyncTask;
//import android.os.Handler;
import android.os.IBinder;
import android.util.Log;

//import com.ingenico.pclutilities.SslObject;
import anywheresoftware.b4a.BA;
//import posintegrado.ingenico.com.mposintegrado.mposLib;

@BA.ActivityObject
@ShortName("PCLServices2")
@DependsOn(values = { "PclUtilities_2.04.00.jar", "PclServiceLib_2.10.00.jar" })
@Permissions(values = { "android.permission.WRITE_EXTERNAL_STORAGE", "android.permission.INTERNET",
        "android.permission.ACCESS_NETWORK_STATE", "android.permission.BLUETOOTH", "android.permission.BLUETOOTH_ADMIN",
        "android.permission.ACCESS_WIFI_STATE" })
@Version(1.00F)
public class PCLServicio2 extends Activity {
    @Hide
    public static BA myba;

    public void Initialize(BA ba) {
        PCLServicio2.myba = ba;
    }

    protected PclService mPclService = null;
    protected boolean mBound = false;
    protected PclUtilities mPclUtil = new PclUtilities(this, "com.ingenico.pcltest", "pairing_addr.txt");
    // protected mposLib mposLibobj;
    protected boolean mServiceStarted;
    protected CharSequence mCurrentDevice;
    private PclServiceConnection mServiceConnection;
    private StateReceiver m_StateReceiver = null;

    // Implement ServiceConnection
    class PclServiceConnection implements ServiceConnection {
        public void onServiceConnected(ComponentName className, IBinder boundService) {
            /*
             * We've bound to LocalService, cast the IBinder and get
             * LocalService instance
             */
            LocalBinder binder = (LocalBinder) boundService;
            mPclService = (PclService) binder.getService();
        }

        public void onServiceDisconnected(ComponentName className) {
            mPclService = null;
        }
    };

    // You can call this method in onCreate for instance
    protected void initService() {
        if (!mBound) {
            mServiceConnection = new PclServiceConnection();
            Intent intent = new Intent(this, PclService.class);
            mBound = bindService(intent, mServiceConnection, Context.BIND_AUTO_CREATE);
        }
    }

    protected void releaseService() {
        if (mBound) {
            unbindService(mServiceConnection);
            mBound = false;
        }
    }

    private class StateReceiver extends BroadcastReceiver {
        @SuppressLint("UseValueOf")
        public void onReceive(Context context, Intent intent) {
            String state = intent.getStringExtra("state");
            // Do appropriate action depending on state
        }
    }

    private void initStateReceiver() {
        if (m_StateReceiver == null) {
            m_StateReceiver = new StateReceiver();
            IntentFilter intentfilter = new IntentFilter("com.ingenico.pclservice.intent.action.STATE_CHANGED");
            registerReceiver(m_StateReceiver, intentfilter);
        }
    }

    private void releaseStateReceiver() {
        if (m_StateReceiver != null) {
            unregisterReceiver(m_StateReceiver);
            m_StateReceiver = null;
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
        initStateReceiver();
    }

    @Override
    protected void onPause() {
        super.onPause();
        releaseStateReceiver();
    }

    public boolean isCompanionConnected() {
        boolean bRet = false;
        if (mPclService != null) {
            byte result[] = new byte[1];
            {
                if (mPclService.serverStatus(result) == true) {
                    if (result[0] == 0x10) {
                        bRet = true;
                    }
                }
            }
        }
        return bRet;
    }

    public void startPclService() {
        if (!mServiceStarted) {
            SharedPreferences settings = getSharedPreferences("PCLSERVICE", MODE_PRIVATE);
            boolean enableLog = settings.getBoolean("ENABLE_LOG", true);
            Intent i = new Intent(BA.applicationContext, PclService.class);
            i.putExtra("PACKAGE_NAME", "posintegrado.ingenico.com.sampleandroidapp");
            i.putExtra("FILE_NAME", "pairing_addr.txt");
            i.putExtra("ENABLE_LOG", enableLog);
            if (getApplicationContext().startService(i) != null)
                mServiceStarted = true;
        }
    }

    private void stopPclService() {
        if (mServiceStarted) {
            Intent i = new Intent(BA.applicationContext, PclService.class);
            if (getApplicationContext().stopService(i))
                mServiceStarted = false;
        }
    }

    class DoTransactionTask extends AsyncTask<Void, Void, Boolean> {
        // declare the parameters that will be used as input and output
        private TransactionIn transIn;
        private TransactionOut transOut;

        public DoTransactionTask(TransactionIn transIn, TransactionOut transOut) {
            // initialization in the class constructor
            this.transIn = transIn;
            this.transOut = transOut;
        }

        protected Boolean doInBackground(Void... tmp) {
            // run the actual PCL function
            // Boolean bRet = doTransaction(transIn, transOut);
            return false; // return bRet;
        }

        protected void onPostExecute(Boolean result) {
            // do the analysis of the returned data of the function
        }
    }

    private String Message;

    public void SendData(String Text) {
        Message = Text;
        runDoTransactionEx();
    }

    protected void runDoTransactionEx() {
        int appNumber;
        TransactionIn transIn = new TransactionIn();
        TransactionOut transOut = new TransactionOut();
        transIn.setAmount("1110");
        transIn.setCurrencyCode("978");
        transIn.setOperation("");
        transIn.setTermNum("");
        transIn.setAuthorizationType("2");
        transIn.setCtrlCheque("");
        transIn.setUserData1("");
        appNumber = Integer.parseInt("58");
        byte[] extDataIn = null;
        try {
            byte[] tmp = Message.getBytes("ISO-8859-1");

            extDataIn = new byte[tmp.length / 2];
            int j = 0;
            for (int i = 0; i < tmp.length; i++) {
                if (tmp[i] >= 'a' && tmp[i] <= 'f')
                    tmp[i] = (byte) (tmp[i] - 'a' + 10);
                else if (tmp[i] >= 'A' && tmp[i] <= 'F')
                    tmp[i] = (byte) (tmp[i] - 'A' + 10);
                else if (tmp[i] >= '0' && tmp[i] <= '9')
                    tmp[i] = (byte) (tmp[i] - '0');
            }
            for (int i = 0; i < tmp.length; i += 2) {
                String str = String.format("%02x", tmp[i] * 16 + tmp[i + 1]);
                extDataIn[j++] = (byte) Integer.parseInt(str, 16);
            }

        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
            BA.Log("TEST ERROR: UnsupportedEncodingException");
            return;
        }
        byte[] extDataOut = new byte[5000];
        Log.d("B4A", "Amount:" + transIn.getAmount() + " Currency:" + transIn.getCurrencyCode() + " Operation:"
                + transIn.getOperation());
        Log.d("B4A", "TermNum:" + transIn.getTermNum() + " AuthoType:" + transIn.getAuthorizationType() + " CtrlCheque:"
                + transIn.getCtrlCheque());
        Log.d("B4A", "UserData:" + transIn.getUserData1());
        BA.Log("TEST STARTED ...\n");
        BA.Log("");
        PclService mPclService = new PclService();
        mPclService.registerCallback(mCallback);
        // mCallbackRegistered = true;
        new DoTransactionExTask(transIn, transOut, appNumber, extDataIn, extDataOut);
    }

    class DoTransactionExTask extends AsyncTask<Void, Void, Boolean> {
        private TransactionIn transIn;
        private TransactionOut transOut;
        private byte[] extDataIn;
        private byte[] extDataOut;
        private long[] extDataOutSize;
        private int appNumber;

        public DoTransactionExTask(TransactionIn transIn, TransactionOut transOut, int appNumber, byte[] extDataIn,
                byte[] extDataOut) {
            this.transIn = transIn;
            this.transOut = transOut;
            this.extDataIn = extDataIn;
            this.extDataOut = extDataOut;
            this.appNumber = appNumber;
            this.extDataOutSize = new long[1];
            this.extDataOutSize[0] = extDataOut.length;
        }

        protected Boolean doInBackground(Void... tmp) {
            return doTransactionEx(transIn, transOut, appNumber, extDataIn, extDataIn.length, extDataOut,
                    extDataOutSize);
        }

        private Boolean doTransactionEx(TransactionIn transIn2, TransactionOut transOut2, int appNumber2,
                byte[] extDataIn2, int length, byte[] extDataOut2, long[] extDataOutSize2) {
            return null;
        }

        protected void onPostExecute(Boolean result) {
            String strResult = "N/A";
            if (result == true) {
                String strExtDataOut;

                // Transform extDataOut in hex
                StringBuffer hex = new StringBuffer();
                String str;
                for (int i = 0; i < extDataOutSize[0]; i++) {
                    str = Integer.toHexString((int) extDataOut[i]);
                    if (str.length() > 2)
                        str = str.substring(str.length() - 2, str.length());
                    else if (str.length() == 1)
                        str = "0" + str;
                    hex.append(str);
                }
                strExtDataOut = hex.toString();

                if (transOut.getC3Error().equals(TransactionOut.ErrorCode.SUCCESS.toString()))
                    strResult = "Transaction OK";
                else
                    strResult = "Transaction KO";

                BA.Log(strResult +
                        "\nAmount:" + transOut.getAmount() +
                        "\nCurrency:" + transOut.getCurrencyCode() +
                        "\nC3Error:" + transOut.getC3Error() +
                        "\nTermNum:" + transOut.getTerminalNumber() +
                        "\nUserData:" + transOut.getUserData() +
                        "\nFFU:" + transOut.getFFU() +
                        "\nExtData:" + strExtDataOut);

            } else {
                BA.Log(strResult);
            }
        }
    }

    private IPclServiceCallback mCallback = new IPclServiceCallback() {
        public void shouldFeedPaper(int lines) {
            Log.d("B4A", "shouldFeedPaper");
            BA.Log("Feed Paper: " + lines + " lines");
            byte[] tmp = new byte[lines];
            for (int i = 0; i < lines; i++)
                tmp[i] = '\n';
            // mtvResult.append(new String(tmp));

        }

        @Override
        public void shouldAddSignature() {
            // TODO Auto-generated method stub

        }

        @Override
        public void shouldCutPaper() {
            // TODO Auto-generated method stub

        }

        @Override
        public void shouldDoSignatureCapture(int arg0, int arg1, int arg2, int arg3, int arg4) {
            // TODO Auto-generated method stub

        }

        @Override
        public int shouldEndReceipt() {
            // TODO Auto-generated method stub
            return 0;
        }

        @Override
        public void shouldPrintImage(Bitmap arg0, byte arg1) {
            // TODO Auto-generated method stub

        }

        @Override
        public void shouldPrintRawText(byte[] arg0, byte arg1, byte arg2, byte arg3, byte arg4, byte arg5, byte arg6,
                byte arg7) {
            // TODO Auto-generated method stub

        }

        @Override
        public void shouldPrintText(String arg0, byte arg1, byte arg2, byte arg3, byte arg4, byte arg5, byte arg6) {
            // TODO Auto-generated method stub

        }

        @Override
        public int shouldStartReceipt(byte arg0) {
            // TODO Auto-generated method stub
            return 0;
        }

        @Override
        public void signatureTimeoutExceeded() {
            // TODO Auto-generated method stub

        }
    };

    public void StartComunication() {
        /* Variable de control si ya se encontró un dispositivo */
        boolean bFound = false;
        /*
         * Se obtiene con esto la lista de los dispositivos ingenico paired con el
         * terminal
         */
        Set<BluetoothCompanion> btComps = mPclUtil.GetPairedCompanions();
        if (btComps != null && (btComps.size() > 0)) {
            /* Loop through paired devices */
            for (BluetoothCompanion comp : btComps) {
                /* Aca se revisa si el dispositivo esta activo y lo define como el actual */
                if (comp.isActivated()) {
                    bFound = true;
                    mCurrentDevice = comp.getBluetoothDevice().getAddress() + " - " +
                            comp.getBluetoothDevice().getName();
                } else {
                    /* Se activa el dispositivo */
                    mPclUtil.ActivateCompanion(comp.getBluetoothDevice().getAddress());
                    return;
                }
            }
        }
    }

}